
# Main Script for Identifying Chemical Species from Graph Analysis

## How to Run the Script

To run the main script, use the following command:

```bash
python3 group_with_double_bonds.py <descriptor_file> <components_file>
```

---

## Helper Scripts

### `information_extraction.py`
This script finds unique structures by parsing the descriptor and component files.

### `double_bond_find.py`
This script identifies double bonds.

### `group_with_double_bonds.py`
This script coordinates the entire process. It outputs both raw data and a normalized version:

- **Raw Data**: Allows for double counting.
- **Normalized Data**: Removes double counting.

Both versions are used for different figures in the publication.

---

## Generated Plots

Two plots will be generated:

1. One using raw data and a conditional probability.
2. Cleaner versions of the plots are generated using the normalized data output.
   
These plots were used for validation, but cleaner versions were used for the final publication.

