import numpy as np
from sklearn.decomposition import PCA
from sklearn.preprocessing import StandardScaler


	
def carbon_dist(master_data):
	tmp_matrix = [0,0,0]
	if master_data[1] < 9 and master_data[1] >2:
		tmp_matrix[0] = master_data[0]*master_data[1]
	elif master_data[1] >=9 and master_data[1] <=11:
		tmp_matrix[1] = master_data[0]*master_data[1]
	elif master_data[1] >11:
		tmp_matrix[2] = master_data[0]*master_data[1]
	return tmp_matrix


def chain_lengthened_find(master_data):
		tmp_var = 0
		if master_data[1] >=11 and master_data[1] -1 == master_data[3] and master_data[1] - 2 == master_data[5]:
				tmp_var = 1
		return tmp_var

def double_bond_find(master_data): #this is still broken but is the skeleton
	tmp_var = 0
	if	 master_data[1]*2 == master_data[2]:
		tmp_var = 1
	return tmp_var
	

def crosslinking_find(master_data):
	cross_link = 0
	if	master_data[1] - 1 == master_data[3] and master_data[1] -1 == master_data[5] and master_data[1] >= 12:
		cross_link = 1
	return cross_link

def crossed_H_group_find(master_data): #experimental may not be accurate
	H_group = 0
	if master_data[1] -1 == master_data[3] and master_data[1]  == master_data[5]:
		H_group = 1
	return H_group

def triangle_find(master_data):
	triangle_group = 0
	triangle_group_middle = 0
	triangle_group_end = 0
	if master_data[1] == master_data[3] and master_data[1] > 0:
		if master_data[1] + 2 == master_data[5]: #middle check
			triangle_group = master_data[0]
			triangle_group_middle = master_data[0]
			triangle_group = 1
		elif master_data[1] + 1 == master_data[5]: #end check
			triangle_group = master_data[0]
			triangle_group_end = master_data[0]
			triangle_group = 1
		elif master_data[1] == master_data[5]:
			triangle_group = 1
	return triangle_group
#	return [triangle_group , triangle_group_middle , triangle_group_end]

def carbon_gas_find(master_data):
	if master_data[1] <=2 and master_data[2] <=6 and master_data[1] >0:
		return 1
	else:
		return 0

def hydrogen_gas_find(master_data):
	if master_data[1] == 0 and master_data[2] == 2:
		return 1
	else:
		return 0

def Y_point_find(master_data):
	Y_branch = 0
	if master_data[1] - 1 == master_data[3] and master_data[1] -1 == master_data[5] and master_data[1] >= 3 and master_data[1] <=11:
#		 Y_branch = master_data[0]
		Y_branch = 1
	return Y_branch

def add_new_data(master_matrix,master_data):
	for i in range(len(master_matrix)):
		if master_matrix[i][1] == 0 and master_matrix[i][2] ==0:
			for j in range(len(master_data)):
					master_matrix[i][j] = master_data[j]
			return master_matrix

def chain_scission(master_data):
	if master_data[1] > 3 and master_data[1] < 9:
		return 1
	return 0

def long_chains(master_data):
	if master_data[1] >=12:
		return 1
	return 0
def mult_hydrogen(master_data):
	if master_data[1] == 0 and master_data[2] > 2:
		return 1
	return 0

#start of the real code is below
def group_data_matrix(input_file):

#		input_file = 'descriptors_carbon_30_ev.txt'
		locations = [1,5,6,7,8,10,11] #locations of the things I want
		#locations are frame , C , H , C-C, C-H ,C-C-C,C-C-H
		master_data = np.zeros(len(locations))

		group_1 = 'Y point'
		group_2 = 'carbon gas'
		group_3 = 'hydrogen gas'
		group_4 = 'cyclization'
		group_5 = 'chain-lengthened'
		group_6 = 'cross-linking'
		group_7 = 'chain scission'
		group_8 = 'CG12'

		groups = [group_1,group_2,group_3,group_4,group_5,group_6,group_7,group_8]
		group_1_matrix = []
		group_2_matrix = []
		function_dict = {group_1 : Y_point_find , group_2 : carbon_gas_find , group_3 : hydrogen_gas_find , \
		group_4 : triangle_find, group_5 : chain_lengthened_find , group_6 : crosslinking_find , group_7 : chain_scission, \
		group_8 : long_chains}
		input_data = np.zeros([1000,len(groups)])
		input_line = -1
		master_matrix = np.zeros([20,len(groups)])
		with open(input_file,'r') as fp_in:
			index = 0
			line = fp_in.readline().split()
			line = fp_in.readline().split()
			for j in range(len(locations)):
				master_data[j] = int(line[locations[j]])
			input_line = master_data[0]
			for j in range(len(master_data)):
				master_matrix[0][j] = master_data[j]
			for line in fp_in:
				line = line.split()
				for j in range(len(master_data)):
					master_data[j] = int(line[locations[j]])
				if master_data[0] == input_line:
					master_matrix = add_new_data(master_matrix,master_data)
					#may ad a break
				elif input_line != master_data[0]:
					tmp = np.zeros(len(input_data[0]))

					for j in range(len(master_matrix)):
						if master_matrix[j][0] == 0 and master_matrix[j][1] == 0 and master_matrix[j][2] == 0:
							break
						for k in range(len(groups)):
							tmp[k] += function_dict[groups[k]](master_matrix[j])
					for j in range(len(groups)):
						input_data[index,j] = tmp[j]
		#				if tmp == 1:
		#					for k in range(len(master_matrix)):
		#						tmp2 = function_dict[group_1](master_matrix[k])
		#						group_2_matrix.append(tmp2)
		#						if tmp2 == 1:

					master_matrix = np.zeros([20,len(groups)])
					input_line = master_data[0]
					master_matrix = add_new_data(master_matrix,master_data)
					index +=1
		tmp = np.zeros(len(input_data[0]))
		for j in range(len(master_matrix)):
			for k in range(len(groups)):
				tmp[k] += function_dict[groups[k]](master_matrix[j])
		for j in range(len(tmp)):
			input_data[index,j] = tmp[j]
		index +=1
		num_frames = index
		input_data = input_data[0:num_frames,:]

		return input_data , groups , num_frames

