
# Network Scrubbing and Analysis Workflow

## 1. Run `network_scrub_sidegroups.f90`

Reads a set of frames in either XYZ or LAMMPSTRJ format that corresponds to the optimized end states of NFRAME simulations.

- You need to set the `NFRAME` value and file names in the code.
- Prints a LAMMPSTRJ file with only backbone atoms.

**Note**: The bond distances with hydrogen atoms in `bond_defs.txt` were set to zero, so hydrogen bonds are not considered in this analysis.

For decane, it might be more useful to include the hydrogens (set bond cutoffs > 0). This way, the scrubbing program will effectively scrub the hydrogens and leave the whole backbones intact. Otherwise, you may lose your terminal carbon atoms.

---

## 2. Run `network_compute_connections.f90`

This program computes network connections from a LAMMPSTRJ file containing backbone atoms. It prints out `NFRAME` files to the directory `connections` for further processing.

The files in the `connections` directory contain the global graph for each frame.

---

## 3. Run `network_run_identify_components.sh`

This script runs a Python script, `network_identify_components.py`, in a loop over the `NFRAME` frames. The script reads files from the `connections` directory and outputs files to the `components` directory. The files in the `components` directory contain the same information as in `connections`, but with individual connected components identified and indexed.

To continue, copy the files in the `components` directory to:

`step2_isomorphism_analysis/dir.backboneComponents`

