
# Graph Isomorphism and Configuration Workflow

## 1. Run `run_writegraphs.sh`

This script processes the component files in `dir.backboneComponents` and writes individual graph files for isomorphism analysis.

- It also produces a file, `graph.record.txt`, which maintains a list linking each graph to a specific frame and component index.

---

## 2. Run `run_analysis_isomorphism.sh`

This script runs the entire isomorphism analysis by calling the Python script `check_isomorphism.py`, which performs isomorphism checks between pairs of graphs.

- It generates a library of all isomorphically unique structures in the `lib.structures/graphs` directory.
- Note that the directory `lib.structures/configs` is not used in this step.
- Additionally, it produces a file, `structures.txt`, which contains the unique structure ID for every graph processed.

---

## 3. Run `run_opt2D.sh`

This script executes the LAMMPS input file `in.pdms`, using a generic force field to create renderable quasi-2D configurations of the unique backbone structures.

For each iteration, the script:

- **A.** Calls `write_datafile.f90` to generate a LAMMPS data file for a specific graph.
- **B.** Executes LAMMPS to unfold the backbone configuration.

A set of LAMMPSTRJ files will be placed in `lib.structures/configs` for rendering with your preferred software (OVITO is recommended).

Make sure to set the `LMP_PATH` variable to point to your LAMMPS executable.

